/*
	File: History.h

	Copyright (c) 1994-6, Adobe Systems Incorporated.
	All rights reserved.

	Utilities for History example export module.
*/

#ifndef __History_H__
#define __History_H__

#include "PIExport.h"
#include "PIUtilities.h"

/*****************************************************************************/

#define trimFirst		3
#define trimLast		trimFirst+1
#define upButton		5
#define downButton		upButton+1
#define statusText		7

#define histTotal		7
#define histItem1		statusText+1
#define histItemEnd		histItem1 + histTotal

#define histResource	'hist'

#define kNoHistories	ResourceID+100
#define kHistStatus		kNoHistories+1

/*****************************************************************************/

extern Handle hDllInstance;

typedef struct Globals
	{

	short result;
	short currentHistory;
	Boolean	queryForParameters;
	ExportRecord *exportParamBlock;

	} Globals, *GPtr, **GHdl;
		
/*****************************************************************************/

#define gResult 				(globals->result)
#define gStuff  				(globals->exportParamBlock)
#define gQueryForParameters		(globals->queryForParameters)
#define gCurrentHistory			(globals->currentHistory)

/*****************************************************************************/

Boolean	ReadScriptParams (GPtr globals);
OSErr	WriteScriptParams (GPtr globals);

void GetHistory (GPtr globals, int16 index, Str255 string);
void DoAbout (GPtr globals);
short DoParameters (GPtr globals);

/*****************************************************************************/

#endif /* __History_H__ */