/*
	File: IllustratorExportUIMac.c

	Copyright (c) 1993-6, Adobe Systems Incorporated.
	All rights reserved.

	C source file for Mac specific UI code for IllustratorExport example.
*/

/*
#include <Types.h>
#include <Errors.h>
#include <Files.h>
#include <Resources.h>
//#include <Quickdraw.h>
#include <Aliases.h>
//#include <String.h>
*/

#include "IllustratorExport.h"

/*****************************************************************************/

/* Displays the about dialog box for the plug-in module. */

void DoAbout (GPtr globals)
{
	ShowAbout (gStuff->hostSig, AboutID);
}

/*****************************************************************************/

/* Display an alert and set gResult = 1. */

void DisplayStopAlert (GPtr globals, short id)
{
	
	ShowStop (hDllInstance, id, 0, NULL, NULL);
	// cross platform caution popper
	
	//	(void) StopAlert (id, NULL);
	
	gResult = 1; // error and return
	
}

/*****************************************************************************/

void DeleteItemsTo (MenuHandle theMenu, short limit)
{
	
	short item = CountMItems (theMenu);
	
	while (item > limit)
		{
		DelMenuItem (theMenu, item);
		--item;
		}
	
}

/*****************************************************************************/

void AppendMenuItem (MenuHandle theMenu, Str255 itemText, short style)
{
	
	short item;
	
	AppendMenu (theMenu, itemText);
	
	item = CountMItems (theMenu);
	
	SetItem (theMenu, item, itemText);
	
	SetItemStyle (theMenu, item, style);
	
}

/*****************************************************************************/

Boolean BuildPathMenu (GPtr globals,
					  MenuHandle theMenu,
					  short *defaultItem)
	{
	
	int32 pathCount;
	
	if (!GetPathCount (globals, &pathCount) || pathCount < 1)
		{
		DeleteItemsTo (theMenu, 1);
		*defaultItem = 1;
		}
		
	else
	{
		
		int32 pathIndex;
		
		int16 workPathIndex = GetPathIndex (globals, propWorkPathIndex);
		int16 clippingPathIndex = GetPathIndex (globals, propClippingPathIndex);
		int16 targetPathIndex = GetPathIndex (globals, propTargetPathIndex);

		DeleteItemsTo (theMenu, (pathCount == 1) ? 2 : 4);
		
		for (pathIndex = 0; pathIndex < pathCount; ++pathIndex)
			{
			
			Str255 name;

			short style = normal;
			
			if (!GetPathName (globals, pathIndex, name))
				return FALSE;
				
			if (pathIndex == clippingPathIndex)
				style |= outline;
				
			if (pathIndex == workPathIndex)
				style |= italic;
				
			AppendMenuItem (theMenu, name, style);
			
			}
		if (*defaultItem < 1)
		{ // defaultItem is zero.  Set it to something.	
			if (pathCount == 1 || targetPathIndex < 0)
				*defaultItem = 3;
			else
				*defaultItem = 5 + targetPathIndex;
		}		
	}
		
	return TRUE;
	
	}

/*****************************************************************************/

pascal short StandardFileHook (short item,
							  DialogPtr theDialog,
							  void *myData)
{
	
	GPtr globals = (GPtr) myData;
	
	if (GetWRefCon (theDialog) != sfMainDialogRefCon)
		return item;
	
	switch (item)
		{
		
		case sfHookFirstCall:
			SetPopUpMenuValue (theDialog, dPopUp, gPopUpValue);
			break;
			
		case sfHookLastCall:
			gPopUpValue = GetPopUpMenuValue (theDialog, dPopUp);
			break;
		
		}
	
	return item;
	
}

/*****************************************************************************/

#if 0
Boolean PromptForFile (GPtr globals)
{
	
	Str255 suffix = "";
	Str255 prompt = "";
	Str255 defaultName = "";
	DialogTHndl dt;
	Point where;
	DlgHookYDUPP myHookUPP;
	
	MenuHandle pathMenu;
	
	/* Construct the file name. */
	
	defaultName [0] = 0;
	AppendStringAndString (defaultName, gStuff->filename);
	PIGetString (suffix, kSuffix);
	AppendStringAndString (defaultName, suffix);
	
	/* Set up the pop-up menu. */
	
	pathMenu = GetMenu (uiID);
	
	if (pathMenu == NULL)
		{
		gResult = ResError ();
		if (gResult == noErr)
			gResult = memFullErr;
		return FALSE;
		}
		
	HNoPurge ((Handle) pathMenu);
		
	if (!BuildPathMenu (globals, pathMenu, &gPopUpValue))
		{
		HPurge ((Handle) pathMenu);
		return FALSE;
		}
	
	/* Get the prompt string. */
	
	PIGetString(prompt, kPrompt);

	/* Center the dialog. */
	
	dt = (DialogTHndl) (GetResource ('DLOG', uiID));
	HNoPurge ((Handle) dt);
	
	CenterDialog (dt);
	where.v = (**dt).boundsRect.top;
	where.h = (**dt).boundsRect.left;
	
	HPurge ((Handle) dt);
	
	/* Ask the user where to save the paths. */
	myHookUPP = NewDlgHookYDProc(StandardFileHook);
	CustomPutFile (prompt, 
				   defaultName,
				   &gReply,
				   uiID,
				   where,
				   myHookUPP,
				   NULL,
				   NULL,
				   NULL,
				   (void *) globals);
	DisposeRoutineDescriptor(myHookUPP);			   
	HPurge ((Handle) pathMenu);
				   
	if (!gReply.sfGood)
		{
		gResult = 1;
		return FALSE;
		}

	return TRUE;
	
}
#endif

/*****************************************************************************/

Boolean PromptForFile (GPtr globals)
{
	
	StandardFileReply	reply;
	FSSpec	*specPtr = NULL;
	Str255 suffix = "";
	Str255 prompt = "";
	Str255 defaultName = "";
	DialogTHndl dt;
	Point where;
	DlgHookYDUPP myHookUPP;
	OSErr gotErr = noErr;
	
	MenuHandle pathMenu;
	
	gotErr = PISetSaveDirectory((Handle)gAliasHandle,
								gStuff->filename, 
					   			gQueryForParameters,
					  			&gStuff->vRefNum);
	PIDisposeHandle((Handle)gAliasHandle); // it was handed to us, it's ours to dispose
	
	if (!gQueryForParameters && !gAliasHandle)
		return FALSE; // no parameters and no aliasHandle.  Bad.

	gAliasHandle = NULL; // just in case
			
	if (!gQueryForParameters)
		return TRUE; // got aliasHandle

	/* Construct the file name. */
	
	gStuff->filename[ gStuff->filename[0]+1 ] = 0; // null terminate filename
	PIGetString(suffix, kSuffix);
	if (PISMatch(gStuff->filename, (char *)&suffix[1]) == noMatch)
	{ // suffix not at end of string.  Add it.
		AppendStringAndString(gStuff->filename, suffix);
	}
	
	/* Set up the pop-up menu. */
	
	pathMenu = GetMenu (uiID);
	
	if (pathMenu == NULL)
		{
		gResult = ResError ();
		if (gResult == noErr)
			gResult = memFullErr;
		return FALSE;
		}
		
	HNoPurge ((Handle) pathMenu);
		
	if (!BuildPathMenu (globals, pathMenu, &gPopUpValue))
		{
		HPurge ((Handle) pathMenu);
		return FALSE;
		}
	
	/* Get the prompt string. */
	
	PIGetString(prompt, kPrompt);

	/* Center the dialog. */
	
	dt = (DialogTHndl) (GetResource ('DLOG', uiID));
	HNoPurge ((Handle) dt);
	
	CenterDialog (dt);
	where.v = (**dt).boundsRect.top;
	where.h = (**dt).boundsRect.left;
	
	HPurge ((Handle) dt);
	
	/* Ask the user where to save the paths. */
	myHookUPP = NewDlgHookYDProc(StandardFileHook);
	CustomPutFile (prompt, 
				   gStuff->filename,
				   &reply,
				   uiID,
				   where,
				   myHookUPP,
				   NULL,
				   NULL,
				   NULL,
				   (void *) globals);
	DisposeRoutineDescriptor(myHookUPP);			   
	HPurge ((Handle) pathMenu);
					   
	if (!TSC (!reply.sfGood))
		return FALSE;
	else
	{
		specPtr = &reply.sfFile;
	
		if (!(gSameNames = (PISMatch(specPtr->name, (char *)gStuff->filename) != noMatch)))
			PICopy(gStuff->filename, specPtr->name, (specPtr->name[0]+1));
		    // shove user-defined name into gStuff filename
			        
		/* set gStuff->vRefNum as working directory (alias) from vRefNum
	   	   from hard vRefNum/parID */
		PICloseAndOpenWD(specPtr->vRefNum, specPtr->parID, &gStuff->vRefNum);
	
		return TRUE;
	}
}
	
/*****************************************************************************/

Boolean QueryForExportFile (GPtr globals)
{
	
	Str255 				prompt;
	StandardFileReply	reply;
	FSSpec				*specPtr;
	Boolean				wasChanged;
	int32				gotErr = 0;
	
	gotErr = PISetSaveDirectory((Handle)gAliasHandle,
								gStuff->filename, 
					   			gQueryForParameters,
					  			&gStuff->vRefNum);
	PIDisposeHandle((Handle)gAliasHandle); // it was handed to us, it's ours to dispose
	gAliasHandle = NULL; // just in case
			
	if (gQueryForParameters)
	{
		
		/* Ask the user */
	
		PIGetString (prompt, kPrompt);

		StandardPutFile (prompt, gStuff->filename, &reply);
		
		if (!TSC (!reply.sfGood))
			return FALSE;
		else
		{
			specPtr = &reply.sfFile;
		
			if (!(gSameNames = (PISMatch(specPtr->name, (char *)gStuff->filename) != noMatch)))
				PICopy(gStuff->filename, specPtr->name, (specPtr->name[0]+1));
			    // shove user-defined name into gStuff filename
				        
			/* set gStuff->vRefNum as working directory (alias) from vRefNum
		   	   from hard vRefNum/parID */
			OpenWD(specPtr->vRefNum, specPtr->parID, 0, &gStuff->vRefNum);
			// don't close working directory given to me by standard file
		
			return TRUE;
		}
	}
	else
		return FALSE; // no parameters and no aliasHandle.  Bad.

}

/*****************************************************************************/

Boolean CreateExportFile (GPtr globals)
{
	ResType	creator;
	ResType type;
	Str255	s = "";
	
	PIGetString(s, kCreatorAndType);
	creator = PIChar2Type((char *)&s[1]);
	type = PIChar2Type((char *)&s[5]);
	
	return PICreateFile(gStuff->filename, 
						gStuff->vRefNum, 
						creator,
						type, 
						&gFRefNum,
						&gResult);
}

/*****************************************************************************/

Boolean CloseExportFile (GPtr globals)
{
	Boolean gotErr = PICloseFile(gStuff->filename,
					   gStuff->vRefNum,
					   gFRefNum,
					   gSameNames,
					   &gStuff->dirty,
					   &gAliasHandle,
					   &gResult);
	gAliasHandle += 1;
	gAliasHandle --;	

/*
	return PICloseFile(gStuff->filename,
					   gStuff->vRefNum,
					   gFRefNum,
					   gSameNames,
					   &gStuff->dirty,
					   &gAliasHandle,
					   &gResult);	
*/
}
	
/*****************************************************************************/
