/*
	File: Outbound.h

	Copyright (c) 1994-6, Adobe Systems Incorporated.
	All rights reserved.

	Utilities for Outbound example export module.
*/

#ifndef __Outbound_H__
#define __Outbound_H__

#include "PITypes.h"
#include "PIGeneral.h"
#include "PIExport.h"
#include "PIUtilities.h"
#include "WinFileUtils.h"
#include "PIActions.h"

/*****************************************************************************/

#define kEditText		4

/*****************************************************************************/
/* The region of the image being exported (an area and a range of planes).   */

typedef struct ExportRegion
	{
	Rect rect;
	int16 loPlane;
	int16 hiPlane;
	}
ExportRegion;

/*****************************************************************************/

OSErr FetchData (ExportRecord *stuff /* in/out */,
				 ExportRegion *region /* in */,
				 void **data /* out */,
				 int32 *rowBytes /* out */);

/*****************************************************************************/

void MarkExportFinished (ExportRecord *stuff);

/*****************************************************************************/

extern Handle hDllInstance;

typedef struct Globals
	{

	short result;
	ExportRecord 	*exportParamBlock;
	Boolean			queryForParameters;
	Boolean			sameNames;
	
	#if Macintosh
	AliasHandle		aliasHandle;
	#else
	Handle			aliasHandle;
	#endif
	
		
	} Globals, *GPtr, **GHdl;
	
/*****************************************************************************/

#define gResult 				(globals->result) // ((*globals).result)
#define gStuff  				(globals->exportParamBlock) // ((*globals).exportParamBlock)
#define gQueryForParameters		(globals->queryForParameters) // ((*globals).queryForParameters)
#define gSameNames				(globals->sameNames)
#define gAliasHandle			(globals->aliasHandle)

/*****************************************************************************/

Boolean	ReadScriptParams (GPtr globals);
OSErr	WriteScriptParams (GPtr globals);
Boolean QueryForExportFile (GPtr globals);
Boolean CreateExportFile (GPtr globals, FileHandle *fRefNum);
Boolean WriteExportFile (GPtr globals, FileHandle fRefNum);
Boolean CloseExportFile (GPtr globals, FileHandle fRefNum);
void DestroyAliasHandle (GPtr globals);
void DoAbout (GPtr globals);

/*****************************************************************************/
#endif /* __Outbound_H__ */